# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files histogramme.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
    sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
sys.path.append("../Supplements/Pro-statdiv/")
from supp_histogramme import *





class Histogramme:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('histogramme.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.radiobuttonAvecAxe = interface.get_object("radiobuttonAvecAxe")
        self.radiobuttonAvecLegende = interface.get_object("radiobuttonAvecLegende")
        self.radiobuttonSansLegende = interface.get_object("radiobuttonSansLegende")
        self.entryListeBornes = interface.get_object("entryListeBornes")
        self.entryListeEffectifs = interface.get_object("entryListeEffectifs")
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryUx = interface.get_object("entryUx")
        self.entryHauteur = interface.get_object("entryHauteur")
        self.entryLx = interface.get_object("entryLx")
        self.entryLy = interface.get_object("entryLy")
        self.entryGx = interface.get_object("entryGx")
        self.entryGy = interface.get_object("entryGy")
        self.entryTO = interface.get_object("entryTO")
        self.entryTA = interface.get_object("entryTA")
        self.entryXminL = interface.get_object("entryXminL")
        self.entryXmaxL = interface.get_object("entryXmaxL")
        self.entryDmin = interface.get_object("entryDmin")
        self.entryDmax = interface.get_object("entryDmax")      
        self.entryNomPM = interface.get_object("entryNomPM")
        self.comboboxCD = interface.get_object("comboboxCD")    
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonCouleurBoite = interface.get_object("checkbuttonCouleurBoite")
        self.checkbuttonCD = interface.get_object("checkbuttonCD")
        self.checkbuttonTO = interface.get_object("checkbuttonTO")
        self.checkbuttonTA = interface.get_object("checkbuttonTA")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    
        self.labelLegende1 = interface.get_object("labelLegende1")  
        self.labelLegende2 = interface.get_object("labelLegende2")
        
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        #Couleur par défaut : orange
        self.comboboxCD.set_active(4)

        
        #désactivation
        self.comboboxCD.set_sensitive(False)
        self.entryTO.set_sensitive(False)
        self.entryTA.set_sensitive(False)
        self.entryXminL.set_sensitive(False)
        self.entryXmaxL.set_sensitive(False)
        self.entryDmin.set_sensitive(False)
        self.entryDmax.set_sensitive(False)
        self.labelLegende1.set_sensitive(False)
        self.labelLegende2.set_sensitive(False)
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowHistogramme_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-histogramme}{1}\n"
        Texte_Code=Texte_Code+"["
        ListeBornes=self.entryListeBornes.get_text()
        ListeBornes=traiter_texte(ListeBornes)
        ListeEffectifs=self.entryListeEffectifs.get_text()
        ListeEffectifs=ListeEffectifs.replace('\\','@')
        Xmin=self.entryXmin.get_text()
        Xmin=Xmin.replace('\\','@')
        Xmax=self.entryXmax.get_text()
        Xmax=Xmax.replace('\\','@')
        Ux=self.entryUx.get_text()
        Ux=Ux.replace('\\','@')
        Hauteur=self.entryHauteur.get_text()
        Hauteur=Hauteur.replace('\\','@')
        Lx=self.entryLx.get_text()
        Lx=Lx.replace('\\','@')
        Ly=self.entryLy.get_text()
        Ly=Ly.replace('\\','@')
        Gx=self.entryGx.get_text()
        Gx=Gx.replace('\\','@') 
        Gy=self.entryGy.get_text()
        Gy=Gy.replace('\\','@') 
        Texte_Code=Texte_Code+ListeBornes+"],\n"
        Texte_Code=Texte_Code+"["+ListeEffectifs+"],\n"
        Texte_Code=Texte_Code+Xmin+","+Xmax+",\n"
        Texte_Code=Texte_Code+Hauteur+",\n"
        Texte_Code=Texte_Code+Ux+",\n"
        Texte_Code=Texte_Code+Lx+","+Ly+",\n"
        Texte_Code=Texte_Code+Gx+","+Gy+",\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-histogramme}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
    def on_entryListeBornes_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryListeEffectifs_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryUx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryHauteur_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryGx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 
        
    def on_entryGy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 

    def on_checkbuttonCD_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonCD.get_active()==True:
            self.comboboxCD.set_sensitive(True)
        else:
            self.comboboxCD.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_checkbuttonTO_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTO.get_active()==True:
            self.entryTO.set_sensitive(True)
        else:
            self.entryTO.set_sensitive(False)
        self.Etat_Compilation=False 
        
    def on_checkbuttonTA_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTA.get_active()==True:
            self.entryTA.set_sensitive(True)
        else:
            self.entryTO.set_sensitive(False)
        self.Etat_Compilation=False 

    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        


    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-statdiv}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-statdiv}")       
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
           
        if self.checkbuttonCD.get_active()==True :
            Couleur=self.comboboxCD.get_active_text()
            Couleur=Nom_Couleur(Couleur)
            Options=Options+"[\"couleur-dessin\",\""
            Options=Options+Couleur
            Options=Options+"\"],\n"  
            
        if self.checkbuttonTO.get_active()==True :
            TO=self.entryTO.get_text()
            TO=traiter_texte(TO)
            Options=Options+"[\"texte-ordonnees\",\""
            Options=Options+TO
            Options=Options+"\"],\n" 
            
        if self.checkbuttonTA.get_active()==True :
            TA=self.entryTA.get_text()
            TA=traiter_texte(TA)
            Options=Options+"[\"texte-abscisses\",\""
            Options=Options+TA
            Options=Options+"\"],\n"    
            
        if self.radiobuttonAvecAxe.get_active()==True :
            self.entryXminL.set_sensitive(False)
            self.entryXmaxL.set_sensitive(False)
            self.entryDmin.set_sensitive(False)
            self.entryDmax.set_sensitive(False)
            self.labelLegende1.set_sensitive(False)
            self.labelLegende2.set_sensitive(False)
        elif self.radiobuttonSansLegende.get_active()==True :
            self.entryXminL.set_sensitive(False)
            self.entryXmaxL.set_sensitive(False)
            self.entryDmin.set_sensitive(False)
            self.entryDmax.set_sensitive(False)
            self.labelLegende1.set_sensitive(False)
            self.labelLegende2.set_sensitive(False)
            Options=Options+"[\"legende-vide\"],\n"
        else:
            self.entryXminL.set_sensitive(True)
            self.entryXmaxL.set_sensitive(True)
            self.entryDmin.set_sensitive(True)
            self.entryDmax.set_sensitive(True)
            self.labelLegende1.set_sensitive(True)
            self.labelLegende2.set_sensitive(True)
            XminL=self.entryXminL.get_text()
            XmaxL=self.entryXmaxL.get_text()
            Dmin=self.entryDmin.get_text()
            Dmax=self.entryDmax.get_text()
            Options=Options+"[\"legende\","+XminL+","+XmaxL+","+Dmin+","+Dmax+"],\n"
            
               
        Options=Options+self.TL.Texte_Libre
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
    def on_comboboxCD_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
            
    def on_entryTO_changed(self,widget):    
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryTA_changed(self,widget):    
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryXminL_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False         
        
    def on_entryXmaxL_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
            
    def on_entryDmin_changed(self,widget):  
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
            
    def on_entryDmax_changed(self,widget):  
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
            
    def on_radiobuttonAvecAxe_clicked(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_radiobuttonAvecLegende_clicked(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False     
    
    def on_radiobuttonSansLegende_clicked(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False         

    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-statdiv}")   
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","histogramme1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-statdiv}")   
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","histogramme1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","histogramme1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","histogramme1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","histogramme1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","histogramme1",self.Etat_Compilation)           


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Histogramme()
    gtk.main()

